app/app/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('bouncer.urls')),
]

app/bouncer/urls.py
"""
URL Mappings for bouncer.
"""

from django.urls import path
from bouncer import views

app_name = 'bouncer'

urlpatterns = [
    path('<str:slug>/', views.handle_redirect, name='redirect'),
    path('', views.landing, name="landing"),
]

app/bouncer/models.py
"""
Datastore models
"""

from google.cloud import ndb


class Redirect(ndb.Model):
    """
    Redirect model.
    """
    name = ndb.StringProperty()
    destination_url = ndb.StringProperty()
    created_on = ndb.DateTimeProperty(auto_now_add=True)

app/bouncer/views.py
"""
Main view functions for handling requests.
"""

from google.cloud import ndb

from django.shortcuts import (
    render,
    redirect,
)
from django.http import Http404

from bouncer.models import Redirect


def landing(request):
    """Render the landing page"""

    redirects = Redirect.query().fetch()

    return render(request, 'bouncer/index.html', {'redirects': redirects})


def handle_redirect(request, slug):
    """
    Handle a redirect.
    """

    redirect_entity = ndb.Key(Redirect, slug).get()
    if not redirect_entity:
        raise Http404('Not found')

    return redirect(redirect_entity.destination_url, permanent=True)

app/bouncer/templates/bouncer/index.html
{% load static %}
<!doctype html>
<html lang="en">
    <head>
        <title>Short URL Links</title>
        <link rel="stylesheet" href="{% static 'style.css' %}"/>
    </head>
    <body>
        <h1>Short URL Links</h1>
        <ul>
            {% for redirect in redirects %}
            <li><a href="{% url 'bouncer:redirect' slug=redirect.key.id %}">{{ redirect.name }}</a></li>
            {% endfor %}
        </ul>
    </body>
</html>